Developer Documentation

Public Slots | Signals | Public Member Functions | Private Slots | Private Member Functions | Private Attributes | List of all members
FileOMPlugin Class Reference
Inheritance diagram for FileOMPlugin:

## Public Slots
int | loadObject (QString _filename)
| Loads Object and converts it to a triangle mesh if possible.
int | loadPolyMeshObject (QString _filename)
| Always loads mesh as polymesh. More...
int | loadTriMeshObject (QString _filename)
| Loads a triangle mesh. More...
bool | saveObject (int _id, QString _filename)
QString | version ()

## Signals
void | openedFile (int _id)
void | addEmptyObject (DataType _type, int &_id)
void | load (QString _filename, DataType _type, int &_id)
void | save (int _id, QString _filename)
void | log (Logtype _type, QString _message)
void | log (QString _message)
void | updateView ()
void | updatedObject (int _identifier, const UpdateType &_type)
void | deleteObject (int _id)
Signals inherited from BaseInterface
virtual void | updateView ()
| Update current view in Main Application. More...
virtual void | setSlotDescription (QString _slotName, QString _slotDescription, QStringList _parameters, QStringList _descriptions)
| Set a description for a public slot. More...
virtual void | setRenderer (unsigned int _viewer, QString _rendererName)
| Set a renderer for the given viewer. More...
Signals inherited from FileInterface
virtual void | openedFile (int _id)
| This signal has to be emitted if an object has been loaded from a file. More...
Signals inherited from LoadSaveInterface
virtual void | save (int _id, QString _filename)
| Save object to a file. More...
virtual void | load (QString _filename, DataType _type, int &_id)
| Load object from file with a specific DataType. More...
Signals inherited from LoggingInterface
virtual void | log (Logtype _type, QString _message)=0
virtual void | log (QString _message)=0
Signals inherited from ScriptInterface
virtual void | scriptInfo (QString _functionWithParameters)
| Emit this signal if a scriptable function is executed. More...
virtual void | getScriptingEngine (QScriptEngine *&_engine)
virtual void | executeScript (QString _script)
virtual void | getAvailableFunctions (QStringList &_functions)

## Public Member Functions
| FileOMPlugin ()
| Constructor.
QString | name ()
| Return a name for the plugin. More...
QString | description ()
| Return a description of what the plugin is doing. More...
DataType | supportedType ()
| Return your supported object type( e.g. DATA_TRIANGLE_MESH ) More...
QString | getSaveFilters ()
QString | getLoadFilters ()
QWidget * | saveOptionsWidget (QString)
QWidget * | loadOptionsWidget (QString)

## Private Slots
void | fileOpened (int)
Private Slots inherited from BaseInterface
virtual void | exit ()
virtual QString | version ()
| Return a version string for your plugin. More...
Private Slots inherited from FileInterface
virtual int | loadObject (QString _filename)=0
| Load an object from the given file. More...
virtual int | loadObject (QString _filename, DataType _type)
| Load an object from the given file. More...

## Private Member Functions
void | noguiSupported ()
void | initializePlugin ()
| Initialize Plugin. More...
void | handleTrimeshDialog ()
| Displays a dialog to ask how to load the mesh (triangle, polymesh , autodetect)
void | slotLoadDefault ()
| Slot called when user wants to save the given Load options as default.
void | slotSaveDefault ()
| Slot called when user wants to save the given Save options as default.
template<class MeshT >
void | backupTextureCoordinates (MeshT &_mesh)
| creates a backup of the original per vertex/face texture coordinates
Private Member Functions inherited from BaseInterface
virtual | ~BaseInterface ()
| Destructor.
virtual void | blockScenegraphUpdates (bool _block)
| Tell the core to prevent scenegraph updates. More...
virtual void | updatedObject (int _objectId)
| An object has been changed or added by this plugin. More...
virtual void | updatedObject (int _identifier, const UpdateType &_type)
| An object has been changed or added by this plugin. More...
virtual void | nodeVisibilityChanged (int _identifier)
| A scenegraph node has been shown or hidden. More...
virtual void | getCurrentRenderer (unsigned int _viewer, QString &_rendererName)
| Get the current renderer for the given viewer. More...
Private Member Functions inherited from FileInterface
virtual | ~FileInterface ()
| Destructor.
virtual bool | saveObject (int _id, QString _filename)=0
| Save an object from the given file. More...
virtual bool | saveObjects (IdList _ids, QString _filename)
| Save multiple objects to one file. More...
Private Member Functions inherited from LoadSaveInterface
virtual | ~LoadSaveInterface ()
| Destructor.
virtual void | addEmptyObject (DataType _type, int &_id)
virtual void | copyObject (int _oldId, int &_newId)
virtual void | emptyObjectAdded (int _id)
| DEPRECATED HERE (Moved to Type Interface)! Emit this signal if an empty object has been created. More...
virtual void | deleteObject (int _id)
| Delete an object This signal can be called from any thread. . More...
virtual void | deleteAllObjects ()
| Delete all Objects. More...
virtual void | getAllFileFilters (QStringList &_filters)
| Get all file filters that are registered. More...
Private Member Functions inherited from LoggingInterface
virtual | ~LoggingInterface ()
| Destructor.
Private Member Functions inherited from ScriptInterface
virtual | ~ScriptInterface ()
| Destructor.
virtual void | executeFileScript (QString _filename)
virtual void | getDescription (QString _function, QString &_description, QStringList &_parameters, QStringList &_descriptions)

## Private Attributes
QWidget * | loadOptions_
QWidget * | saveOptions_
QCheckBox * | saveBinary_
QCheckBox * | saveVertexNormal_
QCheckBox * | saveVertexTexCoord_
QCheckBox * | saveVertexColor_
QCheckBox * | saveFaceColor_
QCheckBox * | saveFaceNormal_
QPushButton * | saveDefaultButton_
QComboBox * | triMeshHandling_
QCheckBox * | loadVertexNormal_
QCheckBox * | loadVertexTexCoord_
QCheckBox * | loadVertexColor_
QCheckBox * | loadFaceColor_
QCheckBox * | loadFaceNormal_
QPushButton * | loadDefaultButton_
int | trimeshOptions_

## Detailed Description

Definition at line 63 of file FileOM.hh.

## Member Function Documentation

## ◆ description()

QString FileOMPlugin::description | ( |  | ) |
| inline virtual

Return a description of what the plugin is doing.

This function has to return a basic description of the plugin

Implements BaseInterface.

Definition at line 111 of file FileOM.hh.

## ◆ getLoadFilters()

QString FileOMPlugin::getLoadFilters | ( |  | ) |
| virtual

Return the Qt Filters for File dialogs when loading files (e.g. "Off files ( *.off )" )

Implements FileInterface.

Definition at line 91 of file FileOM.cc.

## ◆ getSaveFilters()

QString FileOMPlugin::getSaveFilters | ( |  | ) |
| virtual

Get the Qt Filters for Filedialogs when saving files (e.g. "Off files ( *.off )" )

Implements FileInterface.

Definition at line 97 of file FileOM.cc.

## ◆ initializePlugin()

void FileOMPlugin::initializePlugin | ( |  | ) |
| private virtual

Initialize Plugin.

This slot is called if the plugin is loaded and has to be initialized. All initialization stuff in this slot has to stay inside the plugin, no external signals are allowed here (and will be ignored). Don't create any objects via PluginFunctions here. Use the pluginsInitialized() slot for external initialization. After execution of this slot your plugin should be fully functional. Only gui elements may be uninitialized and should be created in pluginsInitialized().

Reimplemented from BaseInterface.

Definition at line 86 of file FileOM.cc.

## ◆ loadOptionsWidget()

QWidget * FileOMPlugin::loadOptionsWidget | ( | QString | _currentFilter | ) |
| virtual

You can provide a special widget showing options for loading your file types depending on the current filter

_currentFilter: one filter from loadFilters

Return 0 when you don't need one

Implements FileInterface.

Definition at line 606 of file FileOM.cc.

## ◆ loadPolyMeshObject

int FileOMPlugin::loadPolyMeshObject | ( | QString | _filename | ) |
| slot

Always loads mesh as polymesh.

load a poly-mesh with given filename

Todo:
  only request if needed

Definition at line 337 of file FileOM.cc.

## ◆ loadTriMeshObject

int FileOMPlugin::loadTriMeshObject | ( | QString | _filename | ) |
| slot

Loads a triangle mesh.

load a triangle-mesh with given filename

Todo:
  only request if needed

Definition at line 260 of file FileOM.cc.

## ◆ name()

QString FileOMPlugin::name | ( |  | ) |
| inline virtual

Return a name for the plugin.

This Function has to return the name of the plugin.

Implements BaseInterface.

Definition at line 110 of file FileOM.hh.

## ◆ noguiSupported()

void FileOMPlugin::noguiSupported | ( |  | ) |
| inline private virtual

Using this function you can inform the core that your plugin can run without creating a widget. If your plugin does not implement this function, it will not be loaded in scripting mode without gui. You don't have to do anything in this function.

Reimplemented from BaseInterface.

Definition at line 91 of file FileOM.hh.

## ◆ saveOptionsWidget()

QWidget * FileOMPlugin::saveOptionsWidget | ( | QString | _currentFilter | ) |
| virtual

You can provide a special widget showing options for saving your file types depending on the current filter

_currentFilter: one filter from saveFilters

Return 0 when you don't need one

Implements FileInterface.

Definition at line 559 of file FileOM.cc.

## ◆ supportedType()

DataType FileOMPlugin::supportedType | ( |  | ) |
| virtual

Return your supported object type( e.g. DATA_TRIANGLE_MESH )

If you support multiple DataTypes you can combine them bitwise here. The function is used from the load and save code to check if your plugin can handle an object of a given dataType.

Implements FileInterface.

Definition at line 103 of file FileOM.cc.

The documentation for this class was generated from the following files:

- PluginCollection-FilePlugins/Plugin-FileOM/FileOM.hh
- PluginCollection-FilePlugins/Plugin-FileOM/FileOM.cc